package jp.naist.se.stigmata.format.xml;

/*
 * $Id: BirthmarkExtractionListXmlFormat.java 20 2007-01-17 02:06:01Z tama3 $
 */

import java.io.PrintWriter;
import java.util.Iterator;

import jp.naist.se.stigmata.Birthmark;
import jp.naist.se.stigmata.BirthmarkElement;
import jp.naist.se.stigmata.BirthmarkSet;
import jp.naist.se.stigmata.format.AbstractBirthmarkExtractionResultFormat;

/**
 * 
 * 
 *
 * @author Haruaki TAMADA
 * @version $Revision: 20 $ $Date: 2007-01-17 11:06:01 +0900 (Wed, 17 Jan 2007) $
 */
public class BirthmarkExtractionListXmlFormat extends AbstractBirthmarkExtractionResultFormat{
    public void printResult(PrintWriter out, BirthmarkSet[] holders){
        out.println("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
        out.println("<stigmata>");
        out.println("  <extracted-birthmarks>");
        for(int i = 0; i < holders.length; i++){
            printBirthmarkHolder(out, holders[i]);
        }
        out.println("  </extracted-birthmarks>");
        out.println("</stigmata>");
    }

    protected void printBirthmarkHolder(PrintWriter out, BirthmarkSet holder){
        out.println("    <extracted-birthmark>");
        out.print("      <class-name>");
        out.print(holder.getClassName());
        out.println("<class-name>");
        out.print("      <location>");
        out.print(holder.getLocation());
        out.println("</location>");
        for(Iterator<String> i = holder.birthmarkTypes(); i.hasNext(); ){
            String type = i.next();
            Birthmark birthmark = holder.getBirthmark(type);
            out.print("      <birthmark type=\"");
            out.print(birthmark.getType());
            out.print("\" count=\"");
            out.print(birthmark.getElementCount());
            out.println("\">");
            for(Iterator<BirthmarkElement> elements = birthmark.iterator(); elements.hasNext(); ){
                out.print("        <element>");
                out.print(elements.next());
                out.println("</element>");
            }

            out.println("      </extracted-birthmark>");
        }
        out.println("    </target>");
    }
}
